#include <stdio.h>
using namespace std;

const int MAX_N = 300000;
const int MAX_h = 1000000;
int h[MAX_h], sin[MAX_N], dx[MAX_N];
char t[MAX_N];

//trovo il max tra i due numeri
inline int max(int a , int b){
	int temp=0;
	if(a>b){
		temp=a;
	}else{
		temp=b;
	}
	return temp;
}



int main ()
{

	int N,K;
	
	//leggo la prima riga contenente N e K,
	//relativamente numero palazzi e punto di partenza

	scanf("%d%d", &N , &K);
	--K ;

	
	
	//leggo l'altezza di ogni palazzo 
	//con un ciclo sul numero dei palazzi
	
	for(int i=0; i<N; i++){
		scanf("%d", h+i);
	}
	
	//leggo la stringa contenente i caratteri "T" e "."
	//che indicano la presenza o meno di un trampolino
	
	scanf("%s", t);
	
	//per ogni palazzo i(partendo da sinistra)
	//se l'altezza di i è inferiore a quello di dx salto l'istruzione
	//perchè Kickass non può saltare sul palazzo (a meno di trampolini)
	//altrimenti lo aggiungo perchè il salto è possibile
	for(int i=1; i<N; ++i){
		if(h[i] < h[i-1]){
			continue;
		}else{
			if(t[i-1] == 'T'){
			t[i] = 'T';}
	sin[i] = 1 + sin[i-1];
		}
	}
	//come nel ciclo precedete ma partendo da dx
	//per ogni palazzo i
	//se l'altezza di i è minore del palazzo a sx salto l'istruzione
	//perchè Kickass non può saltare a meno di trampolini
	//altrimeto lo aggiungo perchè il salto è possibile


	for(int i=N-2; i>=0; --i){
		if(h[i]<h[i+1]){
			continue;
		}else{
			if(t[i+1] == 'T'){
				t[i] = 'T';}
			
			dx[i] = 1 + dx[i+1];
			}
		}
	//controllo su quali palazzi c'è un trampolino
	//for(int i=1;i<N;++i){
	//if (t[i-1]== 'T') t[i]= 'T';
	//}

	//per ogni palazzo 
	//se questo ha un trampolino 
	//aumento il contatore T che mi tiene traccia dei trampolini totali
	//altrimenti aggiungo 1 (il palazzo corrente) al numero dei palazzi (massimo)
	//su sui Kickass può saltare senza trampolini
	
	int temp_soluzione = 0, T=0;
	for(int i=0; i<N; i++)
	{
		if(t[i] == 'T'){
			++T;
		}else{
			temp_soluzione = max(temp_soluzione, 1 + max(sin[i], dx[i]));
		}
	}
	
	//se sul palazzo di partenza ho un trampolino aggiungo uno al numero di palazzi visitati
	//altrimetni controllo i possibili palazzi visitabili prima da sinistra e poi da destra 
	//ritornando il massimo
	
	if (t[K]== 'T'){
		printf("%d\n", T + temp_soluzione);
		}else{ 
		int s = K, d = K;
		
		while(s > 0){
			if (h[s-1] == h[K]){s--;}
		}
		
		while(d < N-1){
					if (h[d+1] == h[K]){d++;}
		}
		
		printf("%d\n", d - s + 1 + max(sin[s], dx[d]));
	}
	return 0;
}
