package trampolin;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;

public class Trampolin {

	public static void main(String asrgs[]) throws NumberFormatException,
			IOException {

		RandomAccessFile file = new RandomAccessFile("trampolin.dummy.in.1",
				"rw");
		RandomAccessFile fileout = new RandomAccessFile("output.txt", "rw");

		String line1 = file.readLine();
		String nums[] = line1.split(" ");
		int numOfSky = Integer.parseInt(nums[0]);
		int startSky = Integer.parseInt(nums[1]) - 1;

		int skyscrapers[] = new int[numOfSky];

		String line2 = file.readLine();
		String numSkys[] = line2.split(" ");

		for (int i = 0; i < numOfSky; i++){
			skyscrapers[i] = Integer.parseInt(numSkys[i]);
			System.out.print(skyscrapers[i]+" ");
		}
		System.out.println();
		String trampolins = file.readLine();
		char visited[] = new char[numOfSky];
		boolean canJump = true;
		int steps = 1;
		int move = 0;
		while (canJump) {

			if (startSky == 0) {
				visited[startSky] = 'X';
				if (trampolins.charAt(1) == 'T') {

					trampolins = "." + trampolins.substring(1);
					startSky = findTrampolin(visited, skyscrapers);
					move = 0;
					if (visited[startSky] != 'X') {
						steps++;
						visited[startSky] = 'X';

					}

				} else {
					if (skyscrapers[startSky + 1] > skyscrapers[startSky])
						break;
					else {
						move = 1; // vengo da sx
						startSky++;
						if (visited[startSky] != 'X') {
							steps++;
							visited[startSky] = 'X';
						}
					}
				}
				
			}
			if(startSky+1>numOfSky)
				break;
			System.out.println("indice: "+startSky);
			move = moveSxOrDX(skyscrapers[startSky - 1], skyscrapers[startSky],skyscrapers[startSky + 1], move);
			System.out.println("move: "+move);
			if (move == -1)
				break;
			else {
				if(move == 1 ){
					startSky--;
					move=2; // vengo da dx
				}	
				else{
					startSky++;
					move=1; // // vengo da sx
				}
				if (visited[startSky] != 'X') {
					steps++;
					visited[startSky] = 'X';

				}
				if (trampolins.charAt(1) == 'T') {
					trampolins = "." + trampolins.substring(1);
					startSky = findTrampolin(visited, skyscrapers);
					move = 0;
					if (visited[startSky] != 'X') {
						steps++;
						visited[startSky] = 'X';

					}
				}
			}
		}
		System.out.println("indice: "+startSky);
		System.out.println(steps);

	}

	public static int findTrampolin(char[] visited, int[] skys) {
		int index = 0;
		int val = 0;
		for (int i = 0; i < skys.length; i++) {
			if (skys[i] >= val && visited[i]!='X')
				index = i;
		}

		return index;
	}

	public static int moveSxOrDX(int a, int me, int b, int old_me) {
		// 1 sx
		// 2 dx
		System.out.println("a: "+a+" me: "+me+" b: "+b+" old_me: "+old_me);
		if (a > me && b <= me && old_me != 2)
			return 2;
		if (a <= me && me >= b && old_me != 1)
			return 1;

		return -1;

	}

}
