#define NDEBUG

#ifndef NDEBUG
    #include <iostream>
#endif

#include <cassert>
#include <fstream>
#include <cstdlib>

using namespace std;

int cost(char* string, int p, int r);

int main(){

    int n;

    ifstream fin("input.txt"); assert(fin);
    fin >> n;
    char list[n];
    for (int i = 0; i < n; i++)
        fin >> list[i];

    ofstream fout("output.txt");
    fout << cost(list, 0, n) << endl;
}

int cost(char* string, int p, int r){
    int length = r-p;

    if (length <= 0){
        return 0;
    }
    else if (length == 1){
        string[p] = ' ';
        return 1; //elimino
    }
    else if (length == 2){
        if (string[p] == '(' && string[p+1] == ')')
            return 0;
        else if (string[p] == ')' && string[p+1] == ')'){
            string[p] = '(';
            return 1;
        }
        else if (string[p] == '(' && string[p+1] == '('){
            string[p+1] = ')';
            return 1;
        }
        else {
            string[p] = '('; string[p+1] = ')';
            return 2;
        }
    }
    else {
        int price = 0;
        int i;
        if (string[p] == ')'){
            if ((length % 2) == 1){
                string[p] = ' ';
                return 1 + cost(string, p+1, r);
            }
            else{
                string[p] = '(';
                price++;
            }
        }
        for (i = 0; (p + 2*i +1) < r; i++)
            if(string[p] == '(' && string[p + 2*i + 1] == ')')
                break;

        return (price + cost(string, p+1, p+2*i + 1) + cost(string, p+2*i+2, r));
    }
}
