#include <cstdio>
#include <iostream>
using namespace std;

//******Variabili globali*******************************************//
const int N =1000000; //numero max di grattacieli che posso avere come input

int height[N],sx[N], dx[N];// height= vettore altezza grattacieli passate da input
						   // sx = vettore che tiene in memoria

char str[N];//stringa di caratteri per identificare i trampolini

//*******************************************************************//

//metodo mi calcola il massimo tra 2 interi
inline int max (int n1,int n2){
	if(n1 > n2)
		return n1;
	else
		return n2;	
										//return n1>n2?n1:n2;
}

int main(){
	int n,sky; //n=totale numero grattacieli---------sky= grattacielo da quale inizio a saltare
	int T=0, best =0;
	FILE *fin,*fout;

	//preparo lo stream per la lettura e scrittura
	fin=fopen("input.txt","r");
	fout=fopen("output.txt","w");
	
	//leggo la prima riga
	fscanf(fin,"%d%d",&n,&sky);
	
	//sottraggo 1 perchè array parte da 0
	--sky;

	//leggo la seconda riga di input -> sequenza di (n) altezza dei grattacieli
	for(int i=0;i<n;i++)		
		fscanf(fin,"%d",height+i);
	
	//leggo la stringa di caratteri(3 riga)formata da soli . e T
		fscanf(fin,"%s",str);

//*******************************Fine lettura***********************************//


	for (int i=1;i<n;++i){
		//continuo portare avanti il puntatore finche trovo grattacieli in ordine di altezza crescente
		if(height[i] < height[i-1]) 
			continue;

		//controllo se c' e un trampolino
		if(str[i-1]== 'T') 
			str[i] ='T';

		sx[i] = 1 + sx[i-1];
	}
	
	//parto sempre dal penultimo a controllare le altezze
	for(int i=n-2;i>=0;--i){
		if(height[i] < height[i+1]) //se altezza prima < altzza dopo allora decremento il puntatore e scorro indietro
			continue;

		//controllo se c' e un trampolino
		if(str[i+1]== 'T') 
			str[i] = 'T';

		dx[i] = 1 + dx[i+1];
	}

	for(int i=0;i<n;i++){
		//inizio contare il numero di caratteri T
		if(str[i]=='T') 
			++T;
		else 
			//cerco prima il max tra i vettori destra e sx, poi il risultato lo confronto con il migliore fin li trovato
			best = max(best,1 + max(sx[i],dx[i]));
	}
	
	//PRIMO CASO
	//se dal grattacielo che inizio a saltare ce un trampolino ho gia trovato il numero di grattacieli che salto
	if(str[sky] == 'T')
		fprintf(fout,"%d\n",T+best);
	
	//SECONDO CASO
	else{
		//faccio partire entrambi i puntatori dal punto che indico di partenza dal input
		int s=sky,d=sky;
		
		//continuo decrementare puntatore sinistro finche l'altezza del grattacielo prima e uguale a quello corrente & non sono arrivato all inizo riga
		while(s>0 && height[s-1]== height[sky]) 
			s--;

		//continuo incrementare puntatore destro finche l'altezza del grattacielo successivo e uguale a quello corrente & non sono arrivato alla fine riga
		while(d < n-1 && height[d+1]==height[sky]) 
			d++;

		//alla fine trovo il numero di grattacieli che posso visitare saltando
		fprintf(fout,"%d\n",d - s + 1 +max(sx[s],dx[d]));
	}
	return 0;
}
