#include <iostream>
#include <fstream>
#include <cassert>
#include <stdio.h>

using namespace std;

const int MAX_N = 300000;

int start;
int n;

int l, t;
char c;

int visited, beforeVisited;
int maxVisited;

//matrice di adiacenza per il grafo
// [da][a]
int matrix[MAX_N][MAX_N];
int arrVisited[MAX_N];
int matrixUsed[MAX_N][MAX_N];

int jumpFrom(int k);

int main() {
	ifstream fin("input.txt"); assert( fin );
  	fin >> n;
	fin >> start;
	
	fin >> l;	//leggo l'altezza del primo palazzo	

	for (int i=1; i<n; i++) {
		fin >> t;
		if (l < t) {
			matrix[t][l] = 1;  //se quello di prima è minore posso saltare da questo a quello di prima
		} else if (l > t) {
			matrix[l][t] = 1;  //se quelo di prima è maggiore posso saltare da quello a questo
		} else {
			matrix[t][l] = 1;
			matrix[l][t] = 1; //se sono uguali posso saltare da uno all'altro
		}
		l = t;
	}

	for (int i=0; i<n; i++) {
		fin >> c;
		if (c=='T') {
			for (int j=0; j<n; j++) {
				matrix[i][j] = 1;	//se c'è un trampolino sul palazzo i posso andare su tutti gli altri
			}
		}
	}
	
	jumpFrom(start);
	ofstream fout("output.txt"); assert( fout );
	fout << maxVisited;
	fout.close();

	return 0;
}

int jumpFrom(int k) {
	for (int i=0; i<n; i++) {
		if (matrix[k][i]==1 && matrixUsed[k][i]==0) {
			beforeVisited = visited;
			matrixUsed[k][i]==1;
			if (arrVisited[i]==0) {
				arrVisited[i]=1;
				visited++;
				maxVisited = max(visited, maxVisited);
			}
			jumpFrom(i);
			arrVisited[i]=0;
			matrixUsed[k][i]=0;
			visited = beforeVisited;
		}
	}


}




