// #include <iostream> // NOTA: ho commentato questa riga per essere sicuro di non aver lasciato operazioni di input/output di debug nella fretta di consegnare, se compila cosi' non ci sono ed io non perdo stupidamente i miei punti-esame.
#include <cstdlib>
#include <fstream>
#include <cassert>

using namespace std;

int n;
int k;
int current_k;
int nMosse;

const int MAX_N = 10000;
const int MAX_K = 100;
int p[MAX_K][MAX_N+1];//vettore permutazioni
int mosse[MAX_K][2*MAX_N+1];//vettore permutazioni
int Min[MAX_K];
int nMosseV[MAX_N*2+1];

void swap( int &a, int &b ) { int tmp = a; a = b; b = tmp; }

int findVal( int* v, int* mosse, int start){
	
//	cout << start << endl;
//	for(int i = start; i < n; i++){		cout << v[i] << " ";	}
	
	for(int i = start; i <= n; i++){
		//cout << v[i] << " " << i << endl;
		if(v[i] != i){//trovato elemento discorde: ora trova valore i+1 e swappa
//			cout << "Elemento discorde: " << i << " " << v[i] << endl;
			for(int j = i+1; j <= n; j++){
				if( v[j] == i ){
					mosse[2*current_k  ] = i;
					mosse[2*current_k+1] = j;
					swap(v[i], v[j]);
					return i+1;
				}
			}
			break;
		}
	}
	return -1;
}

int main(int argc, char *argv[]){
	ifstream fin("input.txt"); assert(fin);
  fin >> n >> k;
  for(int j = 0; j < k; j++)
     for(int i = 1; i <= n; i++)
       fin >> p[j][i];
  fin.close();
  /*cout << "n " << n << " k " << k << endl;
  for(int j = 0; j < k; j++){
     for(int i = 1; i <= n; i++)
       cout << p[j][i] << " ";
     cout << endl;
   }*/
  
  for(int i = 0; i < k; i++){
  	Min[i]    = 1;
  }
	
	//idea: risolviamo tutti i vettori, ci memorizziamo il numero di mosse (mosse pari vanno bene con mosse pari)
	for(int i = 0; i < k; i++){//per tutti i vettori permutazione, trova il minimo numero di mosse per metterlo a posto
		int r = 0;
		nMosse = -1;
		current_k = 0;
		while( r != -1 ){
			r = findVal(p[i], mosse[i], Min[i]);
			if(r != -1) Min[i] = r;//aggiorna punto di partenza
			nMosse ++;
			current_k++;
		}
		nMosseV[i] = nMosse; //numero di mosse per ordinare il vettore i
		//cout << "Vettore " << (i+1) << ": n. mosse = " << nMosse << endl;
	}//fine permutazioni
	
	int pari = 0, dispari = 0;
	int maxPari = 0, maxDispari = 0;
	
	for(int i = 0; i < k; i++){
		if(nMosseV[i] % 2 == 0){
			pari++;
			maxPari = max(nMosseV[i], maxPari);
		} else {
			dispari++;
			maxDispari = max(nMosseV[i], maxDispari);
		}
	}
	int maxMove  = (dispari > pari) ? maxDispari : maxPari;//prendi quello che permette più vettori ordinati
	int maxOrder = max(pari, dispari);
	
	
	ofstream fout("output.txt"); assert(fout);
	fout << maxOrder << " " << maxMove << endl;
	for(int i = 0; i < maxMove; i++){
	  for(int j = 0; j < k; j++){
     	if(mosse[j][i*2] == 0){//fai mossa falsa, non ci sono mosse da fare!
     		fout << "1 2 ";
     	}else{
	     	fout << mosse[j][i*2] << " " << mosse[j][i*2+1] << " ";
     	}
   	}
    fout << endl;
  }
  fout.close();
}
