//============================================================================
// Name        : editFormula.cpp
// Author      : Andrea D'Amico, matricola vr371360
// Version     :
// Copyright   : Your copyright notice
// Description : editFormula in C++, Ansi-style
//============================================================================

#include <iostream>
#include "math.h"
#include "stdio.h"
#include "assert.h"
#include "stdlib.h"
#include <fstream>
#include <vector>
using namespace std;

int move = 0;

int nonega(int* evali, int size)
{
	int gg;
	for ( gg = 0; gg <= size; gg++)
	if(evali[gg] < 0)
		return gg;
return gg;
	}

int flip(char* para, int pos){
if(para[pos] =='(')
	para[pos] =')';
	else
		para[pos] ='(';

move++;
return 0;
}

void  eval(char* para, int* vale, int len){

	int punt = 0 ;

	for (int cont = 0; cont < len; cont++)
	{
		if(para[cont] =='(')
				punt++;
			else
				punt--;

		vale[cont] = punt;
	}
}


void find_max_and_flip(char* para, int* vale, int len, int start)
{
	vector<int> pos;
	int gg;
	int max = 0 - len;
	int max_pos = 0;
	for (gg = 0; gg < len; gg++)
		if(vale[gg] > max)
		{
			max = vale[gg];
			max_pos = gg;
		}
	for (gg = 0; gg < len; gg++)
		if (vale[gg] == max)
	pos.push_back(gg);

	while (pos.size() > 0)
	{
	flip(para, pos.back());
	pos.pop_back();
	}
	}

bool same_open_than_close(char* para, int len)
{
	int open = 0;
	int close = 0;
	for (int gg = 0; gg < len; gg++)
		if(para[gg] == '(')
			open++;
		else
			close++;
	return ((open == close));
	}

int find_partial_ordered(char* para, int* vale, int len)
{
	int gg = len;
	while (vale[gg] != 0 || gg >= 0)
		gg--;
	return gg;
}

int main() {
	  std::cout << " Esame parentificazione" << "\n";
	  ifstream fin;
	  ofstream fout;


	  fin.open("input.txt"); assert(fin);
	  fout.open("output.txt"); assert(fout);

	  int length;

	  fin >> length;

	  char	parent[length];
	  int 	punteggio[length];

	  for (int cont = 0; cont < length; cont++)
		  fin >> parent[cont];

	  eval(parent, punteggio, length);

	  int posa = 0;

	  while (posa < length)
	  {
		  posa = nonega(punteggio, length);
		  if (posa < length)
		  {
		  flip(parent,posa);
		  eval(parent, punteggio, length);
		  }
	  }

	  while (!same_open_than_close(parent, length)){

		  find_max_and_flip(parent, punteggio, length, find_partial_ordered(parent, punteggio, length));
		  eval(parent, punteggio, length);
		  posa = 0;
		  while (posa < length)
		  	  {
		  		  posa = nonega(punteggio, length);
		  		  if (posa < length)
		  		  {
		  		  flip(parent,posa);
		  		  eval(parent, punteggio, length);
		  		  }
		  	  }
		}
	  posa = 0;
	  while (posa < length)
	  	  {
	  		  posa = nonega(punteggio, length);
	  		  if (posa < length)
	  		  {
	  		  flip(parent,posa);
	  		  eval(parent, punteggio, length);
	  		  }
	  	  }

	  	fout << move;

	  	cout << "HO FINITOOOOOOOOOOOOOOOOOO\n";

	  	fin.close();
	  	fout.close();

	return 0;
}
