#include <cstdio>
#include <fstream>
#include <cassert>
#include <string>

using namespace std;

inline int max( int x, int y) {return x>y?x:y; }

const int MAX = 10000005;

int h[MAX], sinistro[MAX], destro [MAX];

char t[MAX];

ofstream fout;

int main(){

	ifstream fin("input.txt"); assert(fin);	

	//printf("\n --TRAMPOLIN -- \n");

	int n, k;
	fin >> n;
	fin >> k;
	// n = numero totale di grattacieli
	// k = grattacielo di partenza

	//printf("\n n == %d   k == %d \n",n,k);
	--k;

	for(int i=0; i<n; i++) fin >> h[i]; // leggo l altezza di tutti i grattacieli 
	fin >> t; // leggo la stringa che mi dice dove c'è il trampolino

	for(int i=1; i<n; ++i){
		if (h[i] < h[i-1]) continue;
		if (t[i-1] == 'T'){
			t[i] = 'T';
		}
		sinistro[i] = 1 + sinistro[i-1];
	}

	for(int i=n-2; i>=0; --i){
		if (h[i] < h[i+1]) continue;
		if (t[i+1] == 'T'){ 
			t[i] = 'T';
		}
		destro[i] = 1 + destro[i+1];
	}

	int T = 0; 
	int best = 0;

	for(int i=0; i<n; i++){
		if (t[i] == 'T'){
			++T;
		}
		else best = max(best, 1+max(sinistro[i], destro[i]));
	}

	fout.open("output.txt");

	if(t[k] == 'T')  fout << T+best;
	else{
		int l = k, d = k;
		while(l > 0 && h[l-1] == h[k]) l--;
		while(d < n-1 && h[d+1] == h[k]) d++;
		fout << d - l + 1 + max(sinistro[l], destro[d]); 
	}
	
	fout.close();	

	return 0;
}

